/* SOD64 the Stack Oriented Design computer.
   Copyright 1994, L.C. Benschop, Eindhoven, The Netherlands.
   The program is released under the GNU General Public License version 2.
   There is NO WARRANTY.
*/

#include <stdio.h>
#include <stdlib.h>
#include "sod64.h"

UNS8 mem[MEMSIZE+7];

UNS64 save_sp,save_ip,save_rp;

void load_image(char *name)
{
 UNS64 len;
 FILE *infile;
 if((infile=fopen(name,"rb"))==NULL) {
  fprintf(stderr,"cannot open image file.\n");
  exit(2);
 }
 len=fread(mem,1,MEMSIZE,infile);
 swap_mem(0,len); 
}
 


int main(int argc,char **argv)
{
 if(argc<2) {
  fprintf(stderr,"Usage: sod64 <filename>\n");
  exit(1);
 }
 load_image(argv[1]);
 virtual_machine();
 return 0;
}
